# Math API

## Angles and vectors
### `angle()`
```{eval-rst}
.. autofunction:: moon_coverage.math.angle
```
### `cs()`
```{eval-rst}
.. autofunction:: moon_coverage.math.cs
```

### `lonlat()`
```{eval-rst}
.. autofunction:: moon_coverage.math.lonlat
```
### `xyz()`
```{eval-rst}
.. autofunction:: moon_coverage.math.xyz
```
### `vdot()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.vdot
```
### `norm()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.norm
```
### `hat()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.hat
```


## Great circles
### `great_circle()`
```{eval-rst}
.. autofunction:: moon_coverage.math.great_circle
```
### `great_circle_arc()`
```{eval-rst}
.. autofunction:: moon_coverage.math.great_circle_arc
```
### `great_circle_pole()`
```{eval-rst}
.. autofunction:: moon_coverage.math.great_circle_pole
```
### `great_circle_path()`
```{eval-rst}
.. autofunction:: moon_coverage.math.greatcircle.great_circle_path
```
### `great_circle_patch()`
```{eval-rst}
.. autofunction:: moon_coverage.math.greatcircle.great_circle_patch
```

## Projections
### `scalar_proj()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.scalar_proj
```
### `scalar_rejection()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.scalar_rejection
```
### `vector_rejection()`
```{eval-rst}
.. autofunction:: moon_coverage.math.vectors.vector_rejection
```

## Sphere functions
### `hav_dist()`
```{eval-rst}
.. autofunction:: moon_coverage.math.hav_dist
```
### `sph_pixel_scale()`
```{eval-rst}
.. autofunction:: moon_coverage.math.sphere.sph_pixel_scale
```
