# SPICE API

## Time convertor API
### `datetime()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.datetime
```
### `sorted_datetimes()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.sorted_datetimes()
```
### `iso()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.iso
```
### `mapps_datetime()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.mapps_datetime
```
### `et()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.et
```
### `et_range()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.et_range
```
### `et_ranges()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.et_ranges
```
### `et_ca_range()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.et_ca_range
```
### `utc()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.utc
```
### `tdb()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.tdb
```
### `sclk()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.times.sclk
```

## Kernel parser API
### `kernel_parser()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.kernel_parser
```
### `format_data()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.format_data
```
### `MetaKernel`
```{eval-rst}
.. autoclass:: moon_coverage.spice.MetaKernel
```

## SPICE objects API
### `SpicePool`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpicePool
```
### `MetaSpicePool`
```{eval-rst}
.. autoclass:: moon_coverage.spice.pool.MetaSpicePool
```
### `SpiceRef`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceRef
```
### `SpiceBody`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceBody
```
### `SpiceObserver`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceObserver
```
### `SpiceSpacecraft`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceSpacecraft
```
### `SpiceInstrument`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceInstrument
```
### `SpiceFieldOfView`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceFieldOfView
```
### `SpiceAbCorr`
```{eval-rst}
.. autoclass:: moon_coverage.spice.SpiceAbCorr
```
### `AbstractSpiceRef`
```{eval-rst}
.. autoclass:: moon_coverage.spice.references.AbstractSpiceRef
```

## SPICE toolbox API
### `deg()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.deg
```
### `rlonlat()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.rlonlat
```
### `radec()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.radec
```
### `sub_obs_pt()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.sub_obs_pt
```
### `sc_state()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.sc_state
```
### `attitude()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.attitude
```
### `intersect_pt()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.intersect_pt
```
### `boresight_pt()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.boresight_pt
```
### `fov_pts()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.fov_pts
```
### `local_time()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.local_time
```
### `illum_angles()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.illum_angles
```
### `sun_pos()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.sun_pos
```
### `solar_longitude()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.solar_longitude
```
### `true_anomaly()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.true_anomaly
```
### `groundtrack_velocity()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.groundtrack_velocity
```
### `pixel_scale()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.toolbox.pixel_scale
```
### `limb_ip_pt()`
```{eval-rst}
.. autofunction:: moon_coverage.spice.limb.limb_ip_pt
```

## SPICE Decorator
### `@check_kernels`
```{eval-rst}
.. autodecorator:: moon_coverage.spice.check_kernels
```
