# Kernel management

The `moon-coverage` is a SPICE based application which requires
a set of [kernels](https://naif.jpl.nasa.gov/naif/kernel_selection.html)
to work. Usually these kernels are provided by the
agency in charge of the space mission you are interested in.
In the case of the ESA/JUICE mission, there kernels can be found in the
ESA-SPICE Service [public FTP](https://spiftp.esac.esa.int/data/SPICE/)
inside the JUICE folder.

:::{Tip}
:class: margin

If you want to manage your kernels on your own, you should take
a look at [this notebook](https://nbviewer.jupyter.org/urls/juigitlab.esac.esa.int/datalab/moon-coverage-notebooks/-/raw/main/notebooks/kernels/spice_kernels.ipynb)
to see how you can do that efficiently.
:::

Knowing which kernel is required for your needs can be complicated, but
usually, your kernel provider will also give you a meta-kernel that contains
the list of all the kernels required for a specific configuration.
In the case of JUICE, these meta-kernels are called
[CReMA](https://www.cosmos.esa.int/web/spice/spice-for-juice).

```{admonition} New in version 0.9.0
If you work with ESA missions, you no longer need to manage and update
your CReMAs manually. The tool will automatically query the
[ESA-SPICE bitbucket](https://repos.cosmos.esa.int/socci/projects/SPICE_KERNELS)
to get the latest version of the metakernels for you.
If you need to use [older versions](../esa/crema), you now have the possibility to explicitly
specify it [at runtime](../spacecraft_trajectory/tour_config.html#skd-version).
```
